<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Tower Attack: towers.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Tower Attack
   </div>
   <div id="projectbrief">A simple console game</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">towers.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef V1_1_TOWERS_H</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define V1_1_TOWERS_H</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &quot;entities.h&quot;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="keyword">using namespace </span><a class="code" href="namespacestd.html">std</a>;</div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="classCMedic.html">   12</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCMedic.html">CMedic</a> : <span class="keyword">public</span> <a class="code" href="classCTower.html">CTower</a> {</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    <a class="code" href="classCMedic.html">CMedic</a> ( <span class="keywordtype">char</span> symbol, <span class="keyword">const</span> <span class="keywordtype">string</span> &amp; name, <span class="keywordtype">int</span> hp, <span class="keywordtype">int</span> attack, <span class="keywordtype">int</span> range, <span class="keywordtype">int</span> parentID )</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        : <a class="code" href="classCTower.html">CTower</a>( symbol, name, hp, attack, range, parentID ),</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;          m_blockingChance(5),     <span class="comment">//one in 5 = 20%</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;          m_resurrectionChance(3), <span class="comment">// one in 3 = 33%</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;          m_restoreChance(5)       <span class="comment">//one in 5 = 20%</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    {}</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <a class="code" href="classCTower.html">CTower</a>    *  clone         ( )<span class="keyword"> const override </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="classCMedic.html">CMedic</a> (*<span class="keyword">this</span>); }     </div><div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="classCMedic.html#a575d27ab551eda2d24c21ffd13d36992">   21</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCMedic.html#a575d27ab551eda2d24c21ffd13d36992">attack</a>                ( <a class="code" href="classCAttacker.html">CAttacker</a> &amp; dst )<span class="keyword"> override </span>{ dst.<a class="code" href="classCAttacker.html#a82ee1f8ecbb8754f223c2eba3cf799a3">defend</a>(*<span class="keyword">this</span>);}    </div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keywordtype">void</span>         defend        ( <a class="code" href="classCAttacker.html">CAttacker</a> &amp; src ) <span class="keyword">override</span>;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keywordtype">void</span>         defend        ( <a class="code" href="classCWarrior.html">CWarrior</a> &amp; src )  <span class="keyword">override</span>;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keywordtype">void</span>         printDetails  ( ostream &amp; os ) <span class="keyword">const override</span>;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keywordtype">void</span>         print         ( ostream &amp; os ) <span class="keyword">const override</span>;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keywordtype">int</span> m_blockingChance;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keywordtype">int</span> m_resurrectionChance;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keywordtype">int</span> m_restoreChance;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;};</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="classCHeavy.html">   38</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCHeavy.html">CHeavy</a> : <span class="keyword">public</span> <a class="code" href="classCTower.html">CTower</a> {</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <a class="code" href="classCHeavy.html">CHeavy</a> ( <span class="keywordtype">char</span> symbol, <span class="keyword">const</span> <span class="keywordtype">string</span> &amp; name, <span class="keywordtype">int</span> hp, <span class="keywordtype">int</span> attack, <span class="keywordtype">int</span> range, <span class="keywordtype">int</span> parentID )</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;            : <a class="code" href="classCTower.html">CTower</a>( symbol, name, hp, attack, range,  parentID ),</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;              m_blockingChance(5), <span class="comment">//one in 5 = 20%</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;              m_attackChance(10) <span class="comment">// one in 10 == 10%</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    {}</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <a class="code" href="classCTower.html">CTower</a>    *  clone         ( )<span class="keyword"> const override </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="classCHeavy.html">CHeavy</a> (*<span class="keyword">this</span>); }  </div><div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="classCHeavy.html#a3b2fe70331aa648035c8a80a7f791647">   46</a></span>&#160;    <span class="keywordtype">void</span>         <a class="code" href="classCHeavy.html#a3b2fe70331aa648035c8a80a7f791647">attack</a>        ( <a class="code" href="classCAttacker.html">CAttacker</a> &amp; dst )<span class="keyword"> override </span>{ dst.<a class="code" href="classCAttacker.html#a82ee1f8ecbb8754f223c2eba3cf799a3">defend</a>(*<span class="keyword">this</span>);} </div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keywordtype">void</span>         defend        ( <a class="code" href="classCAttacker.html">CAttacker</a> &amp; src ) <span class="keyword">override</span> ;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keywordtype">void</span>         printDetails  ( ostream &amp; os ) <span class="keyword">const override</span>;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordtype">void</span>         print         ( ostream &amp; os ) <span class="keyword">const override</span>;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keywordtype">int</span> m_blockingChance;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keywordtype">int</span> m_attackChance;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;};</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="classCArtillery.html">   60</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCArtillery.html">CArtillery</a> : <span class="keyword">public</span> <a class="code" href="classCTower.html">CTower</a> {</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <a class="code" href="classCArtillery.html">CArtillery</a> ( <span class="keywordtype">char</span> symbol, <span class="keyword">const</span> <span class="keywordtype">string</span> &amp; name, <span class="keywordtype">int</span> hp, <span class="keywordtype">int</span> attack, <span class="keywordtype">int</span> range, <span class="keywordtype">int</span> parentID )</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            : <a class="code" href="classCTower.html">CTower</a>( symbol, name, hp, attack, range, parentID ),</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;              m_extendedDistanceChance(4), <span class="comment">//one in 4 = 25%</span></div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;              m_doubleAttackChance(5)      <span class="comment">// one in 5 = 20%</span></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    {}</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <a class="code" href="classCTower.html">CTower</a>    *  clone         ( )<span class="keyword"> const override </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="classCArtillery.html">CArtillery</a> (*<span class="keyword">this</span>); } </div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keywordtype">bool</span>         hasInRange    (<span class="keyword">const</span> <a class="code" href="structTCoord.html">TCoord</a> &amp;src) <span class="keyword">const override</span>;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordtype">void</span>         attack        ( <a class="code" href="classCAttacker.html">CAttacker</a> &amp; dst ) <span class="keyword">override</span>;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keywordtype">void</span>         printDetails  ( ostream &amp; os ) <span class="keyword">const override</span>;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keywordtype">void</span>         print         ( ostream &amp; os ) <span class="keyword">const override</span>;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keywordtype">int</span> m_extendedDistanceChance;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keywordtype">int</span> m_doubleAttackChance;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;};</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="preprocessor">#endif //V1_1_TOWERS_H</span></div><div class="ttc" id="classCMedic_html_a575d27ab551eda2d24c21ffd13d36992"><div class="ttname"><a href="classCMedic.html#a575d27ab551eda2d24c21ffd13d36992">CMedic::attack</a></div><div class="ttdeci">void attack(CAttacker &amp;dst) override</div><div class="ttdoc">Clones this object. </div><div class="ttdef"><b>Definition:</b> towers.h:21</div></div>
<div class="ttc" id="classCTower_html"><div class="ttname"><a href="classCTower.html">CTower</a></div><div class="ttdoc">Tower is one of the main game objects, it can attack and defend itself from other attackers...</div><div class="ttdef"><b>Definition:</b> entities.h:29</div></div>
<div class="ttc" id="namespacestd_html"><div class="ttname"><a href="namespacestd.html">std</a></div></div>
<div class="ttc" id="classCAttacker_html"><div class="ttname"><a href="classCAttacker.html">CAttacker</a></div><div class="ttdoc">Attacker is one of the main game objects, it can attack and defend itself from other towers...</div><div class="ttdef"><b>Definition:</b> entities.h:60</div></div>
<div class="ttc" id="structTCoord_html"><div class="ttname"><a href="structTCoord.html">TCoord</a></div><div class="ttdoc">Coordinates, row and col. </div><div class="ttdef"><b>Definition:</b> coords.h:5</div></div>
<div class="ttc" id="classCWarrior_html"><div class="ttname"><a href="classCWarrior.html">CWarrior</a></div><div class="ttdoc">Warrior 33% chance of blocking attack from artillery, 10 % chance of attacking twice. </div><div class="ttdef"><b>Definition:</b> attackers.h:15</div></div>
<div class="ttc" id="classCHeavy_html"><div class="ttname"><a href="classCHeavy.html">CHeavy</a></div><div class="ttdoc">HEAVY 20% chance of blocking all attacks 10% chance of damage to attacker when hit. </div><div class="ttdef"><b>Definition:</b> towers.h:38</div></div>
<div class="ttc" id="classCMedic_html"><div class="ttname"><a href="classCMedic.html">CMedic</a></div><div class="ttdoc">MEDIC 20% chance of blocking attack coming from Warrior 33% chance of surviving death and restoring 1...</div><div class="ttdef"><b>Definition:</b> towers.h:12</div></div>
<div class="ttc" id="classCHeavy_html_a3b2fe70331aa648035c8a80a7f791647"><div class="ttname"><a href="classCHeavy.html#a3b2fe70331aa648035c8a80a7f791647">CHeavy::attack</a></div><div class="ttdeci">void attack(CAttacker &amp;dst) override</div><div class="ttdoc">Clones this object. </div><div class="ttdef"><b>Definition:</b> towers.h:46</div></div>
<div class="ttc" id="classCArtillery_html"><div class="ttname"><a href="classCArtillery.html">CArtillery</a></div><div class="ttdoc">ARTILLERY 25% Chance of larger distance by half 20% Chance of double shot. </div><div class="ttdef"><b>Definition:</b> towers.h:60</div></div>
<div class="ttc" id="classCAttacker_html_a82ee1f8ecbb8754f223c2eba3cf799a3"><div class="ttname"><a href="classCAttacker.html#a82ee1f8ecbb8754f223c2eba3cf799a3">CAttacker::defend</a></div><div class="ttdeci">virtual void defend(CTower &amp;src)</div><div class="ttdoc">Default defend method of the attackers. </div><div class="ttdef"><b>Definition:</b> entities.cpp:94</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
